| vectorstrip

## Wiki

The master copies of EMBOSS documentation are available at http://emboss.open-bio.org/wiki/Appdocs on the EMBOSS Wiki.

Please help by correcting and extending the Wiki pages.

## Function

Remove vectors from the ends of nucleotide sequence(s)

## Description

vectorstrip reads one or more nucleotide sequences and writes them out again but with any of a specified set of vector sequences removed from the 5' and 3' termini. An output file with a summary of the results is also written. The vector sequences to strip out are (typically) provided in an input file. The pair of 5' and 3' vector sequences are searched against each input sequence allowing a specified maximum level of mismatches. Each 5' hit is paired with each 3' hit and the resulting subsequences output. By default only the best match between the vector patterns and each sequence are reported. Optionally, all matches up to the specified maximum mismatch level are reported.

## Usage

Here is a sample session with vectorstrip

    % vectorstrip @vecseqs.list
    Remove vectors from the ends of nucleotide sequence(s)
    Are your vector sequences in a file? [Y]:
    Cloning vector definition file (optional): vectors
    Max allowed % mismatch [10]:
    Show only the best hits (minimise mismatches)? [Y]:
    Output file [pbluescript.vectorstrip]: vector.strip
    output sequence(s) [pbluescript.fasta]: vector.fasta

Go to the input files for this example
Go to the output files for this example

## Command line arguments

    Remove vectors from the ends of nucleotide sequence(s)
    Version: EMBOSS:6.6.0.0

       Standard (Mandatory) qualifiers (* if not always prompted):
      [-sequence]          seqall     Nucleotide sequence(s) filename and optional
                                      format, or reference (input USA)
      [-[no]readfile]      toggle     [Y] Are your vector sequences in a file?
    *  -vectorsfile        infile     Cloning vector definition file (optional)
       -mismatch           integer    [10] Max allowed % mismatch (Any integer
                                      value)
       -[no]besthits       boolean    [Y] Show only the best hits (minimise
                                      mismatches)?
    *  -alinker            string     The 5' sequence (Any string)
    *  -blinker            string     The 3' sequence (Any string)
      [-outfile]           outfile    [*.vectorstrip] Output file name
      [-outseq]            seqoutall  [.] Sequence set(s)
                                      filename and optional format (output USA)

       Additional (Optional) qualifiers:
       -allsequences       boolean    [N] Show all sequences in output

       Advanced (Unprompted) qualifiers: (none)
       Associated qualifiers:

       "-sequence" associated qualifiers
       -sbegin1            integer    Start of each sequence to be used
       -send1              integer    End of each sequence to be used
       -sreverse1          boolean    Reverse (if DNA)
       -sask1              boolean    Ask for begin/end/reverse
       -snucleotide1       boolean    Sequence is nucleotide
       -sprotein1          boolean    Sequence is protein
       -slower1            boolean    Make lower case
       -supper1            boolean    Make upper case
       -scircular1         boolean    Sequence is circular
       -squick1            boolean    Read id and sequence only
       -sformat1           string     Input sequence format
       -iquery1            string     Input query fields or ID list
       -ioffset1           integer    Input start position offset
       -sdbname1           string     Database name
       -sid1               string     Entryname
       -ufo1               string     UFO features
       -fformat1           string     Features format
       -fopenfile1         string     Features file name

       "-outfile" associated qualifiers
       -odirectory3        string     Output directory

       "-outseq" associated qualifiers
       -osformat4          string     Output seq format
       -osextension4       string     File name extension
       -osname4            string     Base file name
       -osdirectory4       string     Output directory
       -osdbname4          string     Database name to add
       -ossingle4          boolean    Separate file for each entry
       -oufo4              string     UFO features
       -offormat4          string     Features format
       -ofname4            string     Features file name
       -ofdirectory4       string     Output directory

       General qualifiers:
       -auto               boolean    Turn off prompts
       -stdout             boolean    Write first file to standard output
       -filter             boolean    Read first file from standard input, write
                                      first file to standard output
       -options            boolean    Prompt for standard and additional values
       -debug              boolean    Write debug output to program.dbg
       -verbose            boolean    Report some/full command line options
       -help               boolean    Report command line options and exit. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose
       -warning            boolean    Report warnings
       -error              boolean    Report errors
       -fatal              boolean    Report fatal errors
       -die                boolean    Report dying program messages
       -version            boolean    Report version number and exit

Qualifier | Type | Description | Allowed values | Default
--- | --- | --- | --- | ---
Standard (Mandatory) qualifiers
[-sequence] (Parameter 1) | seqall | Nucleotide sequence(s) filename and optional format, or reference (input USA) | Readable sequence(s) | Required
[-[no]readfile] (Parameter 2) | toggle | Are your vector sequences in a file? | Toggle value Yes/No | Yes
-vectorsfile | infile | Cloning vector definition file (optional) | Input file | Required
-mismatch | integer | Max allowed % mismatch | Any integer value | 10
-[no]besthits | boolean | Show only the best hits (minimise mismatches)? | Boolean value Yes/No | Yes
-alinker | string | The 5' sequence | Any string |
-blinker | string | The 3' sequence | Any string |
[-outfile] (Parameter 3) | outfile | Output file name | Output file | <*>.vectorstrip
[-outseq] (Parameter 4) | seqoutall | Sequence set(s) filename and optional format (output USA) | Writeable sequence(s) | <*>.format
Additional (Optional) qualifiers
-allsequences | boolean | Show all sequences in output | Boolean value Yes/No | No
Advanced (Unprompted) qualifiers
(none)
Associated qualifiers
"-sequence" associated seqall qualifiers
-sbegin1 -sbegin_sequence | integer | Start of each sequence to be used | Any integer value | 0
-send1 -send_sequence | integer | End of each sequence to be used | Any integer value | 0
-sreverse1 -sreverse_sequence | boolean | Reverse (if DNA) | Boolean value Yes/No | N
-sask1 -sask_sequence | boolean | Ask for begin/end/reverse | Boolean value Yes/No | N
-snucleotide1 -snucleotide_sequence | boolean | Sequence is nucleotide | Boolean value Yes/No | N
-sprotein1 -sprotein_sequence | boolean | Sequence is protein | Boolean value Yes/No | N
-slower1 -slower_sequence | boolean | Make lower case | Boolean value Yes/No | N
-supper1 -supper_sequence | boolean | Make upper case | Boolean value Yes/No | N
-scircular1 -scircular_sequence | boolean | Sequence is circular | Boolean value Yes/No | N
-squick1 -squick_sequence | boolean | Read id and sequence only | Boolean value Yes/No | N
-sformat1 -sformat_sequence | string | Input sequence format | Any string |
-iquery1 -iquery_sequence | string | Input query fields or ID list | Any string |
-ioffset1 -ioffset_sequence | integer | Input start position offset | Any integer value | 0
-sdbname1 -sdbname_sequence | string | Database name | Any string |
-sid1 -sid_sequence | string | Entryname | Any string |
-ufo1 -ufo_sequence | string | UFO features | Any string |
-fformat1 -fformat_sequence | string | Features format | Any string |
-fopenfile1 -fopenfile_sequence | string | Features file name | Any string |
"-outfile" associated outfile qualifiers
-odirectory3 -odirectory_outfile | string | Output directory | Any string |
"-outseq" associated seqoutall qualifiers
-osformat4 -osformat_outseq | string | Output seq format | Any string |
-osextension4 -osextension_outseq | string | File name extension | Any string |
-osname4 -osname_outseq | string | Base file name | Any string |
-osdirectory4 -osdirectory_outseq | string | Output directory | Any string |
-osdbname4 -osdbname_outseq | string | Database name to add | Any string |
-ossingle4 -ossingle_outseq | boolean | Separate file for each entry | Boolean value Yes/No | N
-oufo4 -oufo_outseq | string | UFO features | Any string |
-offormat4 -offormat_outseq | string | Features format | Any string |
-ofname4 -ofname_outseq | string | Features file name | Any string |
-ofdirectory4 -ofdirectory_outseq | string | Output directory | Any string |
General qualifiers
-auto | boolean | Turn off prompts | Boolean value Yes/No | N
-stdout | boolean | Write first file to standard output | Boolean value Yes/No | N
-filter | boolean | Read first file from standard input, write first file to standard output | Boolean value Yes/No | N
-options | boolean | Prompt for standard and additional values | Boolean value Yes/No | N
-debug | boolean | Write debug output to program.dbg | Boolean value Yes/No | N
-verbose | boolean | Report some/full command line options | Boolean value Yes/No | Y
-help | boolean | Report command line options and exit. More information on associated and general qualifiers can be found with -help -verbose | Boolean value Yes/No | N
-warning | boolean | Report warnings | Boolean value Yes/No | Y
-error | boolean | Report errors | Boolean value Yes/No | Y
-fatal | boolean | Report fatal errors | Boolean value Yes/No | Y
-die | boolean | Report dying program messages | Boolean value Yes/No | Y
-version | boolean | Report version number and exit | Boolean value Yes/No | N

## Input file format

### Input files for usage example

### File: vecseqs.list

    ../../data/bluescript.seq
    ../../data/litmus.seq
    ../../data/pTYB1.seq

### File: vectors

    # Example vector file for use by vectorstrip

    # Vector	5'			3'

    pTYB1   GACGGCGGCCGCGAATTCC     TCGAGGGCTCTTCCTGC
    pBS_KS+ GGGTACCGGGCCCCCCC       TCGAGGTCGACGGTA
    pLITMUS GATATCCTGCAGGAATTCC     TCGAGACCGTACGTGCG

The same fragment has been cloned into the XhoI site of the polylinker of each vector. The cloned fragment is represented in lower case and the vector sequence in upper case so the sequence trimming can be readily seen.

Each line of the vector file should contain the name of the vector, the 5' pattern and the 3' pattern.
Lines beginning with # are treated as comments and ignored.
If only one vector sequence is given in the it will be assumed that this is the 5' pattern.
If a vector name is given but no pattern data, the vector will not be used.

## Output file format

### Output files for usage example

### File: vector.strip

    Sequence: pBlueScript 	 Vector: pTYB1	No match

    Sequence: pBlueScript 	 Vector: pBS_KS+
    5' sequence matches:
    	From 67 to 83 with 0 mismatches
    3' sequence matches:
    	From 205 to 219 with 0 mismatches
    Sequences output to file:
    	from 84 to 204
    		tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagca
    		cacagtgacatgagagacacagatatagagacagatagacgatagacaga
    		cagcatatatagacagatagc
    	sequence trimmed from 5' end:
    		GGAAACAGCTAATGACCATGATTACGCCAAGCGCGCAATTAACCCTCACT
    		AAAGGGAACAAAAGCTGGGTACCGGGCCCCCCC
    	sequence trimmed from 3' end:
    		TCGAGGTCGACGGTATCGATAAGCTTGATATCG

    Sequence: pBlueScript 	 Vector: pLITMUS	No match

    Sequence: litmus.seq 	 Vector: pTYB1	No match

    Sequence: litmus.seq 	 Vector: pBS_KS+	No match

    Sequence: litmus.seq 	 Vector: pLITMUS
    5' sequence matches:
    	From 43 to 61 with 0 mismatches
    3' sequence matches:
    	From 183 to 199 with 0 mismatches
    Sequences output to file:
    	from 62 to 182
    		tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagca
    		cacagtgacatgagagacacagatatagagacagatagacgatagacaga
    		cagcatatatagacagatagc
    	sequence trimmed from 5' end:
    		TCTAGAACCGGTGACGTCTCCCATGGTGAAGCTTGGATCCACGATATCCT
    		GCAGGAATTCC
    	sequence trimmed from 3' end:
    		TCGAGACCGTACGTGCGCGCGAATGCATCCAGATCTTCCCTCTAGTCAAG
    		GCCTTAAGTGAGTCGTATTACGGA

    Sequence: pTYB1.seq 	 Vector: pTYB1
    5' sequence matches:
    	From 40 to 58 with 0 mismatches
    3' sequence matches:
    	From 180 to 196 with 0 mismatches
    Sequences output to file:
    	from 59 to 179
    		tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagca
    		cacagtgacatgagagacacagatatagagacagatagacgatagacaga
    		cagcatatatagacagatagc
    	sequence trimmed from 5' end:
    		CTTTAAGAAGGAGATATACATATGGCTAGCTCGCGAGTCGACGGCGGCCG
    		CGAATTCC
    	sequence trimmed from 3' end:
    		TCGAGGGCTCTTCCTGCTTTGCCAAGGGTACCAATGTTTTAATGGCGGAT

    Sequence: pTYB1.seq 	 Vector: pBS_KS+	No match

    Sequence: pTYB1.seq 	 Vector: pLITMUS	No match

### File: vector.fasta

    >pBlueScript_from_84_to_204 KS+
    tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagcacacagtgaca
    tgagagacacagatatagagacagatagacgatagacagacagcatatatagacagatag
    c
    >litmus.seq_from_62_to_182
    tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagcacacagtgaca
    tgagagacacagatatagagacagatagacgatagacagacagcatatatagacagatag
    c
    >pTYB1.seq_from_59_to_179
    tcgagagccgtattgcgatatagcgcacatgcgttggacacagatgagcacacagtgaca
    tgagagacacagatatagagacagatagacgatagacagacagcatatatagacagatag
    c

Two types of output file are produced:

1. The sequence file(s) - contain the trimmed subsequence(s) produced by vectorstrip either all in one file, or in separate files if the command line flag `-ossingle` is used.
2. Results summary file

## Data files

None.

## Notes

vectorstrip is intended for stripping vector sequence from the ends of sequences of interest. For example, if a fragment has been cloned into a vector and then sequenced, the sequence may contain vector data eg from the cloning polylinker at the 5' and 3' ends of the sequence. vectorstrip will remove these contaminating regions and output trimmed sequence ready for input into another application.

vectorstrip is suitable for use with low quality sequence data as it can allow for mismatches between the sequence and the vector patterns provided. You can specify the maximum level of mismatch expected.

Vector data can either be provided in a file or interactively. If presented in a file, vectorstrip will search all input sequences with all vectors listed in that file. The intention is that the user can maintain a single file for use with vectorstrip, containing all the linker sequences commonly used in the laboratory.

The two patterns for each vector are searched separately against the sequence. Once the search is completed, each of the hits of the 5' sequence is paired with each of the hits of the 3' sequence and the resulting subsequences are output. For example, if the 5' sequence matches the sequence from (a) position 30-60, and(b)position 70-100, and the 3' sequence matches from 150-175, then two subsequences will be output: from 61-149, and from 101-149. The lower the quality of the sequence, the more likely multiple hits become if nonzero mismatches are accepted.

Default behaviour is to report only the best matches between the vector patterns and the sequence. This means that if you specify a maximum mismatch level of 10%, but the vector patterns match the sequence with zero mismatches, the search will stop and the program will output only these "best" matches. If there are no perfect matches, the program will try searching again allowing 1 mismatch, then 2, and so on until either the patterns match the sequence or the maximum specified mismatch level is exceeded. You can tell vectorstrip to show all possible matches up to your specified maximum level, as illustrated in the examples below.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

1.     No suitable vectors found - exiting

   indicates that the 5' and 3' patterns for the vectors were blank - usually this is as a result of an empty vectorfile.

2.     Illegal pattern

   indicates that one of the vector patterns could not be compiled and therefore cannot be searched.

3.     5' and 3' sequence matches are identical; inconclusive

   indicates that the 5' and 3' patterns provided were identical, and that they only match the sequence once. Thus the program cannot determine which part of the sequence is vector and which is insert.

## Exit status

It always exits with status 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
aligncopy | Read and write alignments
aligncopypair | Read and write pairs from alignments
biosed | Replace or delete sequence sections
codcopy | Copy and reformat a codon usage table
cutseq | Remove a section from a sequence
degapseq | Remove non-alphabetic (e.g. gap) characters from sequences
descseq | Alter the name or description of a sequence
entret | Retrieve sequence entries from flatfile databases and files
extractalign | Extract regions from a sequence alignment
extractfeat | Extract features from sequence(s)
extractseq | Extract regions from a sequence
featcopy | Read and write a feature table
featmerge | Merge two overlapping feature tables
featreport | Read and write a feature table
feattext | Return a feature table original text
listor | Write a list file of the logical OR of two sets of sequences
makenucseq | Create random nucleotide sequences
makeprotseq | Create random protein sequences
maskambignuc | Mask all ambiguity characters in nucleotide sequences with N
maskambigprot | Mask all ambiguity characters in protein sequences with X
maskfeat | Write a sequence with masked features
maskseq | Write a sequence with masked regions
newseq | Create a sequence file from a typed-in sequence
nohtml | Remove mark-up (e.g. HTML tags) from an ASCII text file
noreturn | Remove carriage return from ASCII files
nospace | Remove whitespace from an ASCII text file
notab | Replace tabs with spaces in an ASCII text file
notseq | Write to file a subset of an input stream of sequences
nthseq | Write to file a single sequence from an input stream of sequences
nthseqset | Read and write (return) one set of sequences from many
pasteseq | Insert one sequence into another
revseq | Reverse and complement a nucleotide sequence
seqcount | Read and count sequences
seqret | Read and write (return) sequences
seqretsetall | Read and write (return) many sets of sequences
seqretsplit | Read sequences and write them to individual files
sizeseq | Sort sequences by size
skipredundant | Remove redundant sequences from an input set
skipseq | Read and write (return) sequences, skipping first few
splitsource | Split sequence(s) into original source sequences
splitter | Split sequence(s) into smaller sequences
trimest | Remove poly-A tails from nucleotide sequences
trimseq | Remove unwanted characters from start and end of sequence(s)
trimspace | Remove extra whitespace from an ASCII text file
union | Concatenate multiple sequences into a single sequence
yank | Add a sequence reference (a full USA) to a list file

## Author(s)

Val Curwen formerly at:
Sanger Institute, Wellcome Trust Genome Campus, Hinxton, Cambridge, CB10 1SA, UK.

Please report all bugs to the EMBOSS bug team (emboss-bug © emboss.open-bio.org) not to the original author.

## History

16 August 2000 - Val Curwen - Written.

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments

None